30dayMakeOS —— OSASK
===========

《30天自制操作系统》源码中文版。自己制作一个操作系统的过程

阅读过程会一边汉化源码，一边执行还有根据一些相关的内容进行代码的书写，欢迎大家交流。

运行方法，在 `tolset` 中新建一个 `run` 文件夹，把代码拷贝进去，然后根据系统版本运行 `!cons_**.bat`。

一般都是使用 `make run` 运行代码。可以直接看书。

## 内容简介

### 第一周（第1天～第7天）

一开始首先要考虑怎么来写一个“只要一通电就能运行的程序”。这部分用C语言写起来有些困难，所以主要还是用汇编语言来写。

这步完成之后，下一步就要写一个从磁盘读取操作系统的程序。这时即便打开电脑电源，它也不会自动地将操作系统全部都读进来，它只能读取磁盘上最开始的512字节的内容，所以我们要编写剩余部分的载入程序。这个程序也要用汇编语言编写。

一旦完成了这一步，以后的程序就可以用C语言来编写了。我们就尽快使用C语言来学习开发显示画面的程序。同时，我们也能慢慢熟悉C语言语法。这个时候我们好像在做自己想做的事，但事实上我们还没有自由操纵C语言。

接下来，为了实现“移动鼠标”这一雄心，我们要对CPU进行细致的设定，并掌握中断处理程序的写法。从全书总体看来，这一部分是水平相当高的部分，笔者也觉得放在这里有些不妥，但从本书条理上讲，这些内容必须放在这里，所以只好请大家忍耐一下了。在这里，CPU的规格以及电脑复杂的规格都会给我们带来各种各样的麻烦。而且开发语言既有C语言，又有汇编语言，这又给我们造成了更大的混乱。这个时候我们一点儿也不会觉得这是在做自己想做的事，怎么看都像是在“受人摆布”。

渡过这个痛苦的时期，第一周就该结束了。

### 第二周（第8天～第14天）

一周的苦战还是很有意义的，回头一看，我们就会发现自己还是斩获颇丰的。这时我们已经基本掌握了C语言的语法，连汇编语言的水平也能达到本书的要求了。

所以现在我们就可以着手开发像样的操作系统了。但是这一次我们又要为算法头痛了。即使掌握了编程语言的语法，如果不懂得好的算法的话，也还是不能开发出来自己想要的操作系统。

所以这一周我们就边学习算法边慢慢地开发操作系统。不过到了这一阶段，我们就能感觉到基本上不会再受技术问题限制了。

### 第三周（第15天～第21天）

现在我们的技术已经相当厉害了，可以随心所欲地开发自己的操作系统了。首先是要支持多任务，然后是开发命令行窗口，之后就可以着手开发应用程序了。

到本周结束时，就算还不够完备，我们也能拿出一个可以称之为操作系统的软件了。

### 第四周（第22天～第28天）

在这个阶段，我们可以尽情地给操作系统增加各种各样的功能，同时还可以开发出大量像模像样的应用程序来。

这个阶段我们已经能做得很好了，这可能也是我们最高兴的时期。这部分要讲解的内容很少，笔者也不用再煞费苦心地去写那些文字说明了，可以把精力都集中在编程上（笑）。

对了，说起文字才想起来，正好在这个时期可以让我们的操作系统显示文字了。

### 免费赠送两天（第29天～第30天）

剩下的两天用来润色加工。这两天我们来做一些之前没来得及做，但做起来既简单又有趣的内容。

## 川合堂许可协议 
                                                    
### 概要

通俗地说：“这是自由软件，使用前使用后都无须支付任何费用，可以自由使用，也可以
复制、修改，以及用于商业目的，但是作者对软件的bug以及因此所造成的损失不负任何责
任。”

为了保护软件使用者以及软件修改者、参考者的利益，即便作者将来为该软件中所使用的
算法申请专利，也保证不会向使用者收取授权费用。

### 目的

适用于本协议的软件，旨在为公众带来利益，以及为软件技术的进步做出贡献。

#### 宗旨

本协议并不代表作者放弃著作权（仅放弃独家复制发布的权利），使用者可以自由复制并
再次发布本软件的一部分甚至全部内容。使用时无须支付任何费用，对本软件的解析、修改
也无须支付任何费用。

适用于本协议的软件，可以无条件地用作商业目的，甚至可以将软件直接有偿出售。

对于以适用于本协议的软件的一部分或全部内容为基础，在此之上所开发的软件（下称“
派生物”），可以赋予任何种类的许可协议。即，派生物的作者可以禁止对派生物进行复制，
也可以只允许派生物以有偿形式发布。派生物的著作权属于该派生物的生成者，适用于本协
议的软件作者不会对其派生物主张著作权。

在派生物的文档中，没有义务对原始软件的作者进行介绍，但这句话，理所当然地，不意
味着禁止这一行为。

在发布派生物时，没有义务取得原始软件作者的同意，但这句话，理所当然地，不意味着
禁止这一行为。

作者不对软件的质量作出任何保证，因此，由于使用本软件所造成的损害，或者没有达到
所期望的结果，作者不负任何责任。

对于适用于本协议的软件中所使用的技术，除了事先取得作者授权的人以外，禁止其他人
对其申请专利。但如果附加了新的技术并生成了派生物，允许对于追加的部分申请专利。作
者在将来有可能对软件中的技术申请专利，但保证不会向派生物以及软件的使用收取授权费
用。本保证不仅适用于申请专利之前所生成的派生物，也适用于专利取得后所生成的派生物。

将解析结果汇总并申请专利，需要事先取得作者的同意，但对于申请专利以外的行为，没
有任何限制。

### Links

[川合堂](http://www.imasy.org/~mone/kawaido/)

[kawai](http://www.imasy.org/~kawai/)

[豆瓣图书链接](http://book.douban.com/subject/11530329/)

[OSASK计划](http://http://osask.net/)

[OSASK wiki](http://ja.wikipedia.org/wiki/OSASK)

[source code at sourceforge](http://zh.sourceforge.jp/projects/osask/releases/?package_id=10517)

### 工具软件使用

[GNU GPL协议](http://www.gnu.org/licenses/gpl-3.0.html)

[GNU LGPL协议](http://www.gnu.org/licenses/lgpl-3.0.html)